/* Aix s tan sols un exemple de com fer un programa grfic en JAVA.
   Tan sols pretn funcionar... */

/* Aquestes directives ens permeten accedir a un bon nombre de classes
   ja definides */

import java.awt.*;
import java.lang.*;
import java.io.*;

/* Notaci: Les classes comenaran en Majuscula i les instncies, variables i 
   mtodes en minscula */

/* Aquest programa consta d'una classe principal anomenada 'Model'. Aquesta 
   classe s la darrera que es defineix. Abans definim totes les classes a les
   quals crida la classe principal. */

/* La ms important ser la classe 'ModelGui' que heredar de la classe de l'AWT
   'Frame'. */

/* En primer lloc declarem la classe i fem una declaraci de les variables 
   d'instncia. Amb "static" podriem declarar variables de classe, comunes 
   a totes les instncies de la mateixa classe. Amb "final" definiriem 
   constants. Totes aquestes variables sn globals en el sentit de que sn
   accesibles des de tots el mtodes de la classe i, fins i tot, des de 
   mtodes d'altres classes. Tamb declarem les instncies de les classes
   que farem servir */

	class ModelGui extends Frame { 
		TextField a1;			// instncies del GUI
		Scrollbar b1;
		Button c1;
		Button c2;
		Button c3;
		Label lb1;
		Label l1;
		Label l2;
		Label l3;
		Label l4;
		ModelCalculs calcul = null ;	// instncia de clcul
		String nom = "sensenom.dat";	// aquesta variable ha de ser global
		boolean plot = false;		// opcions del programa
		boolean eps = false;
		float pesetes = 0.0f;		// variables que recollim del GUI
		float honrad = 0.5f;

/* El primer mtode s el *constructor*. Es tracta d'un mtode especial, doncs es
   executat cada cop que s'inicialitza una instncia de la classe. El constructor
   pren el mateix nom que la classe. Com a la resta de mtodes, pot haver-hi ms
   d'un constructor amb el mateix nom per diferents parmetres (sobrecarga). */

/* En aquest mtode cal agafar els valors dels parmetres amb els quals hem cridat 
   la instncia. Tamb s un bon lloc per inicialitzar la resta de les variables o 
   per construir la GUI */

	ModelGui(String windowTitle) {
		super(windowTitle);			// Posem nom a la finestra
	}

/* A continuaci venen tots els altres mtodes. Alguns venen imposats per l'AWT, Altres
   s'han definit per la nostra convenincia. Aquests mtodes es poden cridar des 
   d'instncies d'altres classes, degut al modificador "public". */

/* El mtode 'init' s la nostra prpia inicialitzaci (apart de la del constructor). L'haurem 
   de cridar especificament. De fet podem cridar-la en les ocasions que considerem convenient,
   no tan sols al comenament */ 

/* Com que aix s un programa, 'init' s un mtode ms. En canvi, als "applets" el mtode 
   'init' juga un paper especial. */

/* En aquest cas s'utilitza per definir l'estructura que tindr el GUI. */

		public void init() {
			setLayout(new GridLayout(0,1,10,10));
			a1 = new TextField("0");
			b1 = new Scrollbar(Scrollbar.HORIZONTAL,50,1,0,101);
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");     
			c3 = new Button("Sortir");
			lb1 = new Label("0.5");
			l1 = new Label("Pts");
			l2 = new Label("Honradessa");
			l3 = new Label("Euros");
			l4 = new Label("");
			add(l1);
			add(a1);
			add(l2);
			add(lb1);
			add(b1);
			add(l3);
			add(l4);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

/* El mtode action ha d'estar sempre present en un GUI. El ms habitual es separar
   el codi que tracta les accions amb botons del que tracta les accions amb camps
   text. */

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

/* En els dos mtodes segents especifiquem el que cal fer quan t lloc una acci */ 

/* En primer lloc si es pitja un bot... */

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}	

/* ... desprs si s'omple un camp */

		public boolean accioCamp(TextField field) {
//			if(field == a1)
//				System.out.println(a1.getText());
			return true;
		}

/* En aquest mtode interaccionem amb el codi que fa el clcul. */

		public void calcular() {
			pesetes = (float) Integer.parseInt(a1.getText());	// agafem dades
			calcul = new ModelCalculs(pesetes,honrad);		// fem el clcul
			l4.setText(Float.toString(calcul.euros)); 		// actualitzem GUI
			if(plot) {						// sortida gnuplot
				System.out.println("plot '-' with lines");
				System.out.println(Float.toString(calcul.pesetes) + " " + Float.toString(calcul.euros));
				System.out.println("e");
			}
			c2.enable();						// activem salvar
		}

/* Aquest s el mtode que s'encarrega de guardar el resultat */

		public void guardar() { 
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' with lines \n");					
						}
						linia=Float.toString(calcul.pesetes) + " " + Float.toString(calcul.euros) + "\n";
						sortida.write(linia);
						if(eps) {
							sortida.write("e \n");					
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			ModelDialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;
	
			if (confirmar == null)
				confirmar = new ModelDialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;					
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals	
			File fitxer;
			String nomdirectori = "./";
			
			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;					
		}

/* El segent mtode tamb s un mtode que hi ha de ser sempre en un GUI, el tractament dels
   esdeveniments. */

/* El fem servir per matar la finestra i per la lectura de les scrollbar */ 

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
          			case Event.SCROLL_LINE_UP:
          			case Event.SCROLL_LINE_DOWN:
          			case Event.SCROLL_PAGE_UP:
          			case Event.SCROLL_PAGE_DOWN:
          			case Event.SCROLL_ABSOLUTE:
            				if (evt.target == b1)
						honrad=lecturab1(evt);
        		}
        		return super.handleEvent(evt);
    		}

/* Aqu hi ha la conversi entre les unitats de les scrollbar i les unitats finals */

		public float lecturab1(Event evt) {
			int lectura;
			float honra;

			lectura = (((Integer)evt.arg).intValue());
			honra = (float)lectura/100;
			lb1.setText(Float.toString(honra));	// S'ha d'actualitzar l'etiqueta!
			return honra;
		}
	}

/* Fins a aqu arriba la definici de la classe "ModelGui".*/
	
/* Aquesta classe s per demanar confirmaci per sobreescriure un fitxer. El codi comentat
   s un exemple de com accedir a les variables i mtodes de la instncia que la crida. No
   obstant al final s'ha optat per escriure la classe d'una manera que pugui ser utilitzada
   des de qualsevol objecte que heredi de "Frame" i no tan sols "ModelGui". */

	class ModelDialegConfirmar extends Dialog {
//		ModelGui mare;
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		ModelDialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
//			mare = (ModelGui) progenitora;
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");     
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

/* Aquesta classe t el seu propi control.lador d'accions */

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) { 
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}	

/* Final del controlador d'accions */

		public boolean getOpcio() {
		return opcio;
		}
	}

/* Encapsulem els clculs! */

	class ModelCalculs {
		float pesetes;		// Les variables d'instncia, que han de ser
		float honrad;		// accessibles des de fora.
		float euros;

		ModelCalculs(float pts,float hrd) {
			int dummy;

			pesetes = pts;
			honrad = hrd;
			euros = pesetes/(166.386f*honrad);
			euros = euros*100.0f;
			dummy = (int) euros;
			euros = (float) dummy;
			euros = euros/100.0f;
		}
	}

/* La classe principal pren el nom del programa. */

class Model {

	public static void main(String args[]) {
		ModelGui euroCalc = null;		// Declaraci d'instncies.
		
		euroCalc = new ModelGui("Eurocalculadora");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				euroCalc.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				euroCalc.eps = true;
		}
		euroCalc.init();
		euroCalc.show();
	}
}

